<?php

namespace common\logic;

use common\components\ActiveRecordCommon;
use yii\db\ActiveQuery;

abstract class AbstractRepositoryQuery extends AbstractService implements RepositoryQueryInterface
{
    protected ActiveQuery $query;
    protected DefinitionInterface $definition;

    public function createQuery(): self
    {
        $this->query = $this->baseQuery();

        return $this;
    }

    public function __call(string $name, $params): self
    {
        call_user_func_array([$this->query, $name], $params);

        return $this;
    }

    public function count()
    {
        $class = $this->definition->getEntityFqcn();
        $class::groupByPrimaryKey($class, $this->query);

        return $this->query->count();
    }

    public function find()
    {
        return $this->query->all();
    }

    public function findOne()
    {
        return $this->query->one();
    }

    public function filterById(int $id): self
    {
        $this->query->andWhere(['id' => $id]);

        return $this;
    }
}