<?php

namespace common\logic\Config\TaxRate\Repository;

use common\logic\AbstractRepository;
use common\logic\Config\TaxRate\Model\TaxRate;
use yii\db\ActiveQuery;

class TaxRateRepository extends AbstractRepository
{
    protected TaxRateRepositoryQuery $repositoryQuery;

    public function loadDependencies(): void
    {
        $this->repositoryQuery = $this->loadService(TaxRateRepositoryQuery::class);
    }

    public function getDefaultOptionsSearch(): array
    {
        return [
            self::WITH => [],
            self::JOIN_WITH => [],
            self::ORDER_BY => 'pourcent ASC',
            self::ATTRIBUTE_ID_PRODUCER => ''
        ] ;
    }

    public function findOneTaxRateById(int $id): ?TaxRate
    {
        $query = $this->createQuery();
        $query->filterById($id);
        return $query->findOne();
    }

    public function findTaxRates(): array
    {
        $query = $this->createQuery();
        return $query->find();
    }

    public function findTaxRatesAsArray(): array
    {
        $taxRateArrayReturn = [];
        $taxRateArray = $this->findTaxRates();

        foreach($taxRateArray as $taxRate) {
            $taxRateArrayReturn[$taxRate->id] = $taxRate;
        }

        return $taxRateArrayReturn;
    }
}